﻿B4J=true
Group=Handlers
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
' Api Handler class
' Version 2.02
Sub Class_Globals
	Private Request As ServletRequest
	Private Response As ServletResponse
	Private Elements() As String
	Private Method As String
	Private HRM As HttpResponseMessage
End Sub

Public Sub Initialize
	HRM.Initialize
End Sub

Sub Handle (req As ServletRequest, resp As ServletResponse)
	Request = req
	Response = resp
	
	Method = Request.Method.ToUpperCase
	ProcessRequest
End Sub

Private Sub ElementLastIndex As Int
	Return Elements.Length - 1
End Sub

Private Sub ProcessRequest
    #Region Example
	' ============================================================================
	' What is Index and Element? Controller, First, Second and Last?
	' ============================================================================
	' For URL: http://127.0.0.1:8080/web/api/v2/data/:index/:key
	' 					  |      |    |   |	 |   |		|	  |
	'  			 Root URL ┘		 |    |   |	 |   |		|	  |
	'                Server Port ┘    |   |	 |   |		|	  |
	'    					Root Path ┘   |	 |   |		|	  |
	' 							 API Name ┘	 |   |		|	  |
	'                    APIVersionIndex = 3 ┘   |		|	  |
	'						 ControllerIndex = 4 ┘		|	  |
	'									 FirstIndex = 5 ┘	  |
	'							 (last index) SecondIndex = 6 ┘
	'
	' Index is the position of an element inside the URL
	' If Controller is used, at least ControllerIndex has to be used
	' FirstIndex, SecondIndex, etc are optional
	' ElementLastIndex returns the last position of the rightmost element of URL
	' In this template, we only have a single controller name DataController
	' ============================================================================
    #End Region
	Log(Request.RequestURI)
	Elements = Utility.GetUriElements(Request.RequestURI)
	If ElementLastIndex < Main.Element.ApiControllerIndex Then
		Utility.ReturnBadRequest(Response)
		Return
	End If

	Dim ApiVersionIndex As Int = Main.Element.ApiVersionIndex
	Dim ControllerIndex As Int = Main.Element.ApiControllerIndex
	Dim ApiVersionElement As String = Elements(ApiVersionIndex)
	Dim ControllerElement As String = Elements(ControllerIndex)
	
	Select ControllerElement
		Case "download"
			RouteDownload(ApiVersionElement, ControllerIndex)
		Case Else
			Log("Unknown controller: " & ControllerElement)
			Utility.ReturnBadRequest(Response)
	End Select
End Sub

Private Sub RouteDownload (Version As String, ControllerIndex As Int)
	Select Method
		Case "GET"
			RouteDownloadGet(Version, ControllerIndex)
	End Select
End Sub

Private Sub RouteDownloadGet (Version As String, ControllerIndex As Int)
	Dim Download As DownloadController
	Download.Initialize(Request, Response)
	Select ElementLastIndex
		Case ControllerIndex
			Select Version
				Case "v2"
					Download.GetPDF
					Return
			End Select
	End Select
End Sub